#pragma once
#include "globalsymboldatabase.h"

class TSCANCODELIB CheckZqTest : public Check
{
public:
	CheckZqTest() : Check(myName())
	{ }

	/** @brief This constructor is used when running checks. */
	CheckZqTest(const Tokenizer *tokenizer, const Settings *settings, ErrorLogger *errorLogger)
		: Check(myName(), tokenizer, settings, errorLogger)
	{

	}

	void runChecks(const Tokenizer *tokenizer, const Settings *settings, ErrorLogger *errorLogger)
	{
		printf("In %s:%u\n", __FUNCTION__, __LINE__);
	}



	/** @brief Run checks against the simplified token list */
	void runSimplifiedChecks(const Tokenizer *tokenizer, const Settings *settings, ErrorLogger *errorLogger)
	{
		CheckZqTest temp(tokenizer, settings, errorLogger);
		printf("In %s:%u\n", __FUNCTION__, __LINE__);

		temp.debug_info_output();

	}

	std::string classInfo() const
	{
		return "TSC zq test checks";
	}

	void getErrorMessages(ErrorLogger *errorLogger, const Settings *settings) const
	{
	}

	static std::string myName()
	{
		return "CheckZqTest";
	}

	void SetReportedErrors(std::set<const Token*>* reportedErrors);

private:
	void debug_info_output();
};
